/* TABLIX, PGA highschool timetable generator                              */
/* Copyright (C) 2002 Tomaz Solc                                           */

/* This program is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by    */
/* the Free Software Foundation; either version 2 of the License, or       */
/* (at your option) any later version.                                     */

/* This program is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/* GNU General Public License for more details.                            */

/* You should have received a copy of the GNU General Public License       */
/* along with this program; if not, write to the Free Software             */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */

/* $Id: timeplace.c,v 1.4 2004/10/17 09:37:05 avian Exp $ */

/* 
 * AUTHOR:
 *  
 *  Tomaz Solc <tomaz.solc@siol.net>
 *
 * DESCRIPTION:
 *
 *  Adds a weight whenever two subject-teacher pairs are scheduled in the 
 *  same room at the same time.
 *
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "modsup.h"
#include "data.h"
#include "gettext.h"

int grade_function(chromo *t, int *cpnt, int *tpnt, int **start, int **lead)
{
	int a,b,c;
	int sum;
	int *pnt;

	sum=0;

        for(c=0;c<tuplenum;c++) {
                a=t->inf[c].time;

                for(pnt=start[a];pnt<lead[a];pnt++) if (*pnt<c) {
                        b=*pnt;
                        if (t->inf[c].room==t->inf[b].room) {
                                sum++;
			}
		}
	}

	return(sum);
}
